// Code generated by go-swagger; DO NOT EDIT.

package packer_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-packer-service/stable/2021-04-30/models"
	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
)

// PackerServiceDeleteBuildReader is a Reader for the PackerServiceDeleteBuild structure.
type PackerServiceDeleteBuildReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PackerServiceDeleteBuildReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPackerServiceDeleteBuildOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewPackerServiceDeleteBuildDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPackerServiceDeleteBuildOK creates a PackerServiceDeleteBuildOK with default headers values
func NewPackerServiceDeleteBuildOK() *PackerServiceDeleteBuildOK {
	return &PackerServiceDeleteBuildOK{}
}

/*
PackerServiceDeleteBuildOK describes a response with status code 200, with default header values.

A successful response.
*/
type PackerServiceDeleteBuildOK struct {
	Payload models.HashicorpCloudPackerDeleteBuildResponse
}

// IsSuccess returns true when this packer service delete build o k response has a 2xx status code
func (o *PackerServiceDeleteBuildOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this packer service delete build o k response has a 3xx status code
func (o *PackerServiceDeleteBuildOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this packer service delete build o k response has a 4xx status code
func (o *PackerServiceDeleteBuildOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this packer service delete build o k response has a 5xx status code
func (o *PackerServiceDeleteBuildOK) IsServerError() bool {
	return false
}

// IsCode returns true when this packer service delete build o k response a status code equal to that given
func (o *PackerServiceDeleteBuildOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the packer service delete build o k response
func (o *PackerServiceDeleteBuildOK) Code() int {
	return 200
}

func (o *PackerServiceDeleteBuildOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2021-04-30/organizations/{location.organization_id}/projects/{location.project_id}/builds/{build_id}][%d] packerServiceDeleteBuildOK %s", 200, payload)
}

func (o *PackerServiceDeleteBuildOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2021-04-30/organizations/{location.organization_id}/projects/{location.project_id}/builds/{build_id}][%d] packerServiceDeleteBuildOK %s", 200, payload)
}

func (o *PackerServiceDeleteBuildOK) GetPayload() models.HashicorpCloudPackerDeleteBuildResponse {
	return o.Payload
}

func (o *PackerServiceDeleteBuildOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPackerServiceDeleteBuildDefault creates a PackerServiceDeleteBuildDefault with default headers values
func NewPackerServiceDeleteBuildDefault(code int) *PackerServiceDeleteBuildDefault {
	return &PackerServiceDeleteBuildDefault{
		_statusCode: code,
	}
}

/*
PackerServiceDeleteBuildDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type PackerServiceDeleteBuildDefault struct {
	_statusCode int

	Payload *cloud.GoogleRPCStatus
}

// IsSuccess returns true when this packer service delete build default response has a 2xx status code
func (o *PackerServiceDeleteBuildDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this packer service delete build default response has a 3xx status code
func (o *PackerServiceDeleteBuildDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this packer service delete build default response has a 4xx status code
func (o *PackerServiceDeleteBuildDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this packer service delete build default response has a 5xx status code
func (o *PackerServiceDeleteBuildDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this packer service delete build default response a status code equal to that given
func (o *PackerServiceDeleteBuildDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the packer service delete build default response
func (o *PackerServiceDeleteBuildDefault) Code() int {
	return o._statusCode
}

func (o *PackerServiceDeleteBuildDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2021-04-30/organizations/{location.organization_id}/projects/{location.project_id}/builds/{build_id}][%d] PackerService_DeleteBuild default %s", o._statusCode, payload)
}

func (o *PackerServiceDeleteBuildDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2021-04-30/organizations/{location.organization_id}/projects/{location.project_id}/builds/{build_id}][%d] PackerService_DeleteBuild default %s", o._statusCode, payload)
}

func (o *PackerServiceDeleteBuildDefault) GetPayload() *cloud.GoogleRPCStatus {
	return o.Payload
}

func (o *PackerServiceDeleteBuildDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud.GoogleRPCStatus)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
