// Code generated by go-swagger; DO NOT EDIT.

package packer_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-packer-service/stable/2023-01-01/models"
	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
)

// PackerServiceDeleteChannelReader is a Reader for the PackerServiceDeleteChannel structure.
type PackerServiceDeleteChannelReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PackerServiceDeleteChannelReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPackerServiceDeleteChannelOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewPackerServiceDeleteChannelDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPackerServiceDeleteChannelOK creates a PackerServiceDeleteChannelOK with default headers values
func NewPackerServiceDeleteChannelOK() *PackerServiceDeleteChannelOK {
	return &PackerServiceDeleteChannelOK{}
}

/*
PackerServiceDeleteChannelOK describes a response with status code 200, with default header values.

A successful response.
*/
type PackerServiceDeleteChannelOK struct {
	Payload models.HashicorpCloudPacker20230101DeleteChannelResponse
}

// IsSuccess returns true when this packer service delete channel o k response has a 2xx status code
func (o *PackerServiceDeleteChannelOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this packer service delete channel o k response has a 3xx status code
func (o *PackerServiceDeleteChannelOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this packer service delete channel o k response has a 4xx status code
func (o *PackerServiceDeleteChannelOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this packer service delete channel o k response has a 5xx status code
func (o *PackerServiceDeleteChannelOK) IsServerError() bool {
	return false
}

// IsCode returns true when this packer service delete channel o k response a status code equal to that given
func (o *PackerServiceDeleteChannelOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the packer service delete channel o k response
func (o *PackerServiceDeleteChannelOK) Code() int {
	return 200
}

func (o *PackerServiceDeleteChannelOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2023-01-01/organizations/{location.organization_id}/projects/{location.project_id}/buckets/{bucket_name}/channels/{channel_name}][%d] packerServiceDeleteChannelOK %s", 200, payload)
}

func (o *PackerServiceDeleteChannelOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2023-01-01/organizations/{location.organization_id}/projects/{location.project_id}/buckets/{bucket_name}/channels/{channel_name}][%d] packerServiceDeleteChannelOK %s", 200, payload)
}

func (o *PackerServiceDeleteChannelOK) GetPayload() models.HashicorpCloudPacker20230101DeleteChannelResponse {
	return o.Payload
}

func (o *PackerServiceDeleteChannelOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPackerServiceDeleteChannelDefault creates a PackerServiceDeleteChannelDefault with default headers values
func NewPackerServiceDeleteChannelDefault(code int) *PackerServiceDeleteChannelDefault {
	return &PackerServiceDeleteChannelDefault{
		_statusCode: code,
	}
}

/*
PackerServiceDeleteChannelDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type PackerServiceDeleteChannelDefault struct {
	_statusCode int

	Payload *cloud.GoogleRPCStatus
}

// IsSuccess returns true when this packer service delete channel default response has a 2xx status code
func (o *PackerServiceDeleteChannelDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this packer service delete channel default response has a 3xx status code
func (o *PackerServiceDeleteChannelDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this packer service delete channel default response has a 4xx status code
func (o *PackerServiceDeleteChannelDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this packer service delete channel default response has a 5xx status code
func (o *PackerServiceDeleteChannelDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this packer service delete channel default response a status code equal to that given
func (o *PackerServiceDeleteChannelDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the packer service delete channel default response
func (o *PackerServiceDeleteChannelDefault) Code() int {
	return o._statusCode
}

func (o *PackerServiceDeleteChannelDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2023-01-01/organizations/{location.organization_id}/projects/{location.project_id}/buckets/{bucket_name}/channels/{channel_name}][%d] PackerService_DeleteChannel default %s", o._statusCode, payload)
}

func (o *PackerServiceDeleteChannelDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /packer/2023-01-01/organizations/{location.organization_id}/projects/{location.project_id}/buckets/{bucket_name}/channels/{channel_name}][%d] PackerService_DeleteChannel default %s", o._statusCode, payload)
}

func (o *PackerServiceDeleteChannelDefault) GetPayload() *cloud.GoogleRPCStatus {
	return o.Payload
}

func (o *PackerServiceDeleteChannelDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud.GoogleRPCStatus)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
